- #projects [[New computer 2023]] Gnome vs. Window managers
	- Gnome
		- pro
			- looks beautiful by default
			- good touch pad gestures
		- con
			- keyboard centered workflow requires additional config.
				- [paperWM](https://github.com/paperwm/PaperWM)
				- [Pop-os shell](https://github.com/pop-os/shell) might not support gnome 43
				- forge
	- Window managers like sway
		- pro
			- keyboard-centered workflow is fast and suits laptops well
			- looks good [unixporn](https://www.reddit.com/r/unixporn)
			- fun to use and configure
		- con
			- have to configure many stuff by hand
			  collapsed:: true
				- 1. Multi-screen setup
				  2. volume management that looks decent
				  3. various xdg-desktop portals
			- Color management
			- automatic theme switching and night mode configuration
			- sway and Hyprland have bad support for nvidia
	- Additional notes
		- I think I will try sway and hypr TWM, and fall back to gnome. Use flatpak for large desktop applications
		- [2022 status of nvidia's wayland driver on Sway and Gnome](https://blog.devgenius.io/wayland-and-nvidia-in-2022-2f0407fb34f4?gi=db52b330779c)
		- When installing gnome, disable extra flag to reduce bloat
-
- [[New computer 2023]] Cool linux rices
	- [SwayWM](https://www.reddit.com/r/unixporn/comments/124yjwy/minimalistic_sway_waybar_nixos_full_silent_boot/)
	- [Hyprland](https://www.reddit.com/r/unixporn/comments/12315m9/hyprland_updating_dotfiles_again/) the bar looks pretty decent
-
- [[New computer 2023]] Stuff to remember
	- Data in my home folder (Better back up them)
		- SSH keys, TOTP keys
		- Documents - Personal
		- Flatpak steam stuff
	- Gentoo specific
		- gentoo-lto by default
		- NVIDIA drivers
		- Gnome/systemd profile (install gnome and gdm first then other WM)
-
- Todo
	- Personal
		- DONE Try putting my blogs on medium
		  SCHEDULED: <2023-04-01 Sat>
		- DONE Theme flatpak apps
		  SCHEDULED: <2023-04-01 Sat>
		-
-
- Daily reflection [[Daily reflections]]
	- What I've done
		- Review school stuff
		- Didn't read books :(
	- What I've thought #thoughts
		- After watching youtube 1 hour straight, I feel some kind of bad.
		  My parents have been a hindrance to my personal development, and they
		  obviously don't want to commit that. They are bad, lame, unresponsive and in general disappointing.
	- Mood
		- For the most part great, because I feel spring is coming
-
- PittCS's Leetcode problem sets: #leetcode #excluded_in_query
  id:: 6423af98-f01f-4c69-a2a3-6b38715bd077
  collapsed:: true
	- ### DONE Week 1 - Arrays
		- DONE [Contains Duplicate](https://leetcode.com/problems/contains-duplicate/)
		  :LOGBOOK:
		  CLOCK: [2023-03-29 Wed 11:31:49]--[2023-03-29 Wed 11:35:13] => 00:03:24
		  :END:
		- DONE [Two Sum](https://leetcode.com/problems/two-sum/) [[Leetcode Two-Sum]]
		  :LOGBOOK:
		  CLOCK: [2023-03-29 Wed 11:35:42]--[2023-03-29 Wed 11:49:32] => 00:13:50
		  :END:
		- DONE [Buy & Sell Stock](https://leetcode.com/problems/best-time-to-buy-and-sell-stock/) [[Leetcode Best-Time-To-Buy-And-Sell-Stock]]
		  :LOGBOOK:
		  CLOCK: [2023-03-30 Thu 07:41:08]--[2023-03-30 Thu 07:51:53] => 00:10:45
		  :END:
		- DONE [Product of Array Except Self](https://leetcode.com/problems/product-of-array-except-self/) [[Leetcode Product-of-Array-Except-Self]]
		  :LOGBOOK:
		  CLOCK: [2023-03-30 Thu 07:53:22]--[2023-03-30 Thu 08:01:25] => 00:08:03
		  :END:
		- DONE [Maximum Subarray](https://leetcode.com/problems/maximum-subarray/) [[Leetcode Maxinum-subarray]]
		  :LOGBOOK:
		  CLOCK: [2023-03-31 Fri 08:06:18]--[2023-03-31 Fri 08:15:11] => 00:08:53
		  :END:
		- DONE [Maximum Product Subarray](https://leetcode.com/problems/maximum-product-subarray/) ((64261f45-6885-422c-808c-9344273af1d4))
		  :LOGBOOK:
		  CLOCK: [2023-03-31 Fri 08:23:01]--[2023-03-31 Fri 08:38:24] => 00:15:23
		  :END:
		- DONE [Game of Life (**Bonus**)](https://leetcode.com/problems/game-of-life/) ((6428db9f-8f14-41a4-b5ec-5e79ffeb204a))
		  :LOGBOOK:
		  CLOCK: [2023-04-02 Sun 09:36:45]--[2023-04-02 Sun 09:36:50] => 00:00:05
		  CLOCK: [2023-04-02 Sun 09:50:33]--[2023-04-02 Sun 10:18:21] => 00:27:48
		  :END:
	- #### DONE Week 1 - Arrays Resources
		- DONE [Sets in Python](https://youtu.be/sBvaPopWOmQ)
		- DONE [Dictionaries in Python](https://youtu.be/XCcpzWs-CI4)
		- DONE [Traversing 2D Lists in Python](https://youtu.be/B5GhlXhDfoE)
	- ### LATER Week 2 - Arrays + Intervals
	  :LOGBOOK:
	  CLOCK: [2023-04-02 Sun 14:57:17]--[2023-04-02 Sun 14:57:20] => 00:00:03
	  :END:
		- DONE [Min Rotate Sort Array](https://leetcode.com/problems/find-minimum-in-rotated-sorted-array/) ((64294296-85d5-4d21-b815-b4bad7525df5))
		  :LOGBOOK:
		  CLOCK: [2023-04-02 Sun 16:12:11]--[2023-04-02 Sun 16:53:34] => 00:41:23
		  :END:
		- DONE [Search Rotate Sort Array](https://leetcode.com/problems/search-in-rotated-sorted-array/) ((642aa126-13d8-48ff-8eb4-f17d875add97))
		  :LOGBOOK:
		  CLOCK: [2023-04-02 Sun 17:14:27]--[2023-04-02 Sun 17:40:32] => 00:26:05
		  :END:
		- DONE [3Sum](https://leetcode.com/problems/3sum/) ((642abd85-5c14-42c3-aa39-e7dc2773b2ec))
		  :LOGBOOK:
		  CLOCK: [2023-04-03 Mon 19:09:33]--[2023-04-03 Mon 19:50:58] => 00:41:25
		  :END:
		- DONE [Container w Most Water](https://leetcode.com/problems/container-with-most-water/) ((642ac7bd-a908-4155-b839-f58ca64f4672))
		  :LOGBOOK:
		  CLOCK: [2023-04-03 Mon 19:55:22]--[2023-04-03 Mon 20:32:51] => 00:37:29
		  :END:
		- DONE [Insert Interval](https://leetcode.com/problems/insert-interval/) ((642cd1a8-9707-4dc2-9d03-11464553e618))
		  :LOGBOOK:
		  CLOCK: [2023-04-05 Wed 10:37:25]--[2023-04-05 Wed 10:37:26] => 00:00:01
		  :END:
		- DONE [Merge Intervals](https://leetcode.com/problems/merge-intervals/) ((642edfd2-c458-484e-9e94-8802771475d5))
		  :LOGBOOK:
		  CLOCK: [2023-04-06 Thu 08:56:14]--[2023-04-06 Thu 09:33:45] => 00:37:31
		  :END:
		- DONE [Happy Number (**Bonus**)](https://leetcode.com/problems/happy-number/)
	- #### DONE Week 2 - Arrays Resources
		- LATER [How Binary Search Makes Computers Much, Much Faster](https://youtu.be/KXJSjte_OAI)
		- LATER [Introduction to Binary Search](https://www.youtube.com/watch?v=6ysjqCUv3K4)
		- LATER [Algorithms: Binary Search](https://www.youtube.com/watch?v=P3YID7liBug)
	- ### LATER Week 3 - Intervals + Matrix
		- DONE [Non-overlapping Intervals](https://leetcode.com/problems/non-overlapping-intervals/) ((643d27e0-7330-4510-a2f7-8e2cecc08e7b))
		- DONE [Meeting Rooms I](https://www.leetcode.com/problem/meeting-rooms/) This quesion is premium only
		- DONE [Set Matrix Zeroes](https://leetcode.com/problems/set-matrix-zeroes/)
		- DONE [Spiral Matrix](https://leetcode.com/problems/spiral-matrix/)
		- DONE [Rotate Img](https://leetcode.com/problems/rotate-image/) ((64422d1f-5db3-435d-ab4e-2b9fe5fd47cd))
		- LATER [Word Search](https://leetcode.com/problems/word-search/)
		- LATER [Sliding Window Max (**Bonus**)](https://leetcode.com/problems/sliding-window-maximum/)
	- #### LATER Week 3 - Matrix Resources
		- LATER [2D Lists & Nested Loops - Python](https://youtu.be/B5GhlXhDfoE)
	- ### LATER Week 4 - Linked Lists
		- LATER [Reverse Linked List](https://leetcode.com/problems/reverse-linked-list/)
		- LATER [Linked List Cycle](https://leetcode.com/problems/linked-list-cycle/)
		- LATER [Merge 2 Sorted Lists](https://leetcode.com/problems/merge-two-sorted-lists/)
		- LATER [Merge k Sorted Lists](https://leetcode.com/problems/merge-k-sorted-lists/)
		- LATER [Remove Nth Node](https://leetcode.com/problems/remove-nth-node-from-end-of-list/)
		- LATER [Reorder List](https://leetcode.com/problems/reorder-list/)
		- LATER [Sort Colors (**Bonus**)](https://leetcode.com/problems/sort-colors/)
	- #### LATER Week 4 - Linked Lists Resources
		- LATER [Data Structures: Linked Lists](https://youtu.be/njTh_OwMljA)
		- LATER [Introduction to Linked Lists](https://youtu.be/WwfhLC16bis)
		- LATER [Data Structures: Heaps](https://youtu.be/X4RWHH69Gi8)
		- LATER [HeapQ for Algorithms in Python](https://youtu.be/X4RWHH69Gi8)
	- ### LATER Week 5 - String
		- LATER [Reverse String](https://leetcode.com/problems/reverse-string/)
		- LATER [Valid Anagram](https://leetcode.com/problems/valid-anagram/)
		- LATER [Valid Parentheses](https://leetcode.com/problems/valid-parentheses/)
		- LATER [Valid Palindrome](https://leetcode.com/problems/valid-palindrome/)
		- LATER [Group Anagrams](https://leetcode.com/problems/group-anagrams/)
		- LATER [Longest Palindromic Substring](https://leetcode.com/problems/longest-palindromic-substring/)
		- LATER [Palindromic Substrings](https://leetcode.com/problems/palindromic-substrings/)
		- LATER [Odd Even Linked List (**Bonus**)](https://leetcode.com/problems/odd-even-linked-list/)
	- #### LATER Week 5 - String Resources
		- LATER [Python Stacks](https://youtu.be/NKmasqr_Xkw)
	- ### LATER Week 6 - String + Trees
		- LATER [Minimum Window Substring](https://leetcode.com/problems/minimum-window-substring/)
		- LATER [Longest Repeating Char Replacement](https://leetcode.com/problems/longest-repeating-character-replacement/)
		- LATER [Longest Substring Without Repeating Characters](https://leetcode.com/problems/longest-substring-without-repeating-characters/)
		- LATER [Tree Inorder Traversal](https://leetcode.com/problems/binary-tree-inorder-traversal/)
		- LATER [Tree Preorder Traversal](https://leetcode.com/problems/binary-tree-preorder-traversal/)
		- LATER [Tree Postorder Traversal](https://leetcode.com/problems/binary-tree-postorder-traversal/)
		- LATER [Encode + Decode Strings](https://www.lintcode.com/problem/encode-and-decode-strings/)
		- LATER [Max Depth of Binary Tree](https://leetcode.com/problems/maximum-depth-of-binary-tree/)
		- LATER **Bonus** - Do all the Tree traversal problems iteratively
		- LATER [Find Duplicate Number (**Bonus**)](https://leetcode.com/problems/find-the-duplicate-number/)
	- #### LATER Week 6 - Trees Resources
		- LATER [Data Structures: Trees](https://www.youtube.com/watch?v=oSWTXtMglKE)
	- ### LATER Week 7 - Trees
		- LATER [Same Tree](https://leetcode.com/problems/same-tree/)
		- LATER [Invert Binary Tree](https://leetcode.com/problems/invert-binary-tree/)
		- LATER [Binary Tree Max Path Sum](https://leetcode.com/problems/binary-tree-maximum-path-sum/)
		- LATER [Binary Tree Level Order Traversal](https://leetcode.com/problems/binary-tree-level-order-traversal/)
		- LATER [Serialize + Deserialize Binary Tree](https://leetcode.com/problems/serialize-and-deserialize-binary-tree/)
		- LATER [Subtree of Another Tre](https://leetcode.com/problems/subtree-of-another-tree/)
		- LATER [LRU Cache (Bonus)](https://leetcode.com/problems/lru-cache/)
	- ### LATER Week 8 - Trees
		- LATER [Construct Binary Tree From Preorder and Inorder Traversal](https://leetcode.com/problems/construct-binary-tree-from-preorder-and-inorder-traversal/)
		- LATER [Validate BST](https://leetcode.com/problems/validate-binary-search-tree/)
		- LATER [Kth Smallest Element in BST](https://leetcode.com/problems/kth-smallest-element-in-a-bst/)
		- LATER [LCA of BST](https://leetcode.com/problems/lowest-common-ancestor-of-a-binary-search-tree/)
		- LATER [Implement Trie](https://leetcode.com/problems/implement-trie-prefix-tree/)
		- LATER [Design Add + Search Words Data Structure](https://leetcode.com/problems/design-add-and-search-words-data-structure/)
		- LATER [University Career Fair (**Bonus**)](https://cdn.discordapp.com/attachments/758353765174083595/840082064090595388/cHg7Bod.png)
	- ### LATER Week 9 - Graphs
		- LATER [Number of Islands](https://leetcode.com/problems/number-of-islands/)
		- LATER [All Paths from Src](https://leetcode.com/problems/all-paths-from-source-to-target/)
		- LATER [Word Search II](https://leetcode.com/problems/word-search-ii/)
		- LATER [Clone Graph](https://leetcode.com/problems/clone-graph/)
		- LATER [Course Schedule](https://leetcode.com/problems/course-schedule/)
		- LATER [Pacific Atlantic Water Flow](https://leetcode.com/problems/pacific-atlantic-water-flow/)
		- LATER [Longest Consecutive Seq](https://leetcode.com/problems/longest-consecutive-sequence/)
		- LATER [Longest Common Prefix (**Bonus**)](https://leetcode.com/problems/longest-common-prefix/)
	- #### LATER Week 9 - Graph Resources
		- LATER [Introduction to Graphs](https://youtu.be/gXgEDyodOJU)
		- LATER [Multi-part Graph Lecture Series](https://youtu.be/c8P9kB1eun4)
		- LATER [WilliamFiset's Graph Theory Videos](https://www.youtube.com/watch?v=DgXR2OWQnLc&list=PLDV1Zeh2NRsDGO4--qE8yH72HFL1Km93P)
	- ### LATER Week 10 - Graphs
		- LATER [Number of Connected Comps in Graph](https://protegejj.gitbook.io/algorithm-practice/leetcode/graph/323-number-of-connected-components-in-an-undirected-graph)
		- LATER [Word Search II](https://leetcode.com/problems/word-search-ii/)
		- LATER [Alien Dictionary](https://www.lintcode.com/problem/alien-dictionary/)
		- LATER [Graph Valid Tree](https://www.lintcode.com/problem/graph-valid-tree/)
		- LATER [Top K Frequent Elements](https://leetcode.com/problems/top-k-frequent-elements/)
		- LATER [Find Median from Data Stream](https://leetcode.com/problems/find-median-from-data-stream/)
		- LATER [Daily Temp (**Bonus**)](https://leetcode.com/problems/daily-temperatures/)
	- ### LATER Week 11 - Dynamic Programming
		- LATER [Climbing Stairs](https://leetcode.com/problems/climbing-stairs/)
		- LATER [House Robber](https://leetcode.com/problems/house-robber/)
		- LATER [House Robber II](https://leetcode.com/problems/house-robber-ii/)
		- LATER [Coin Change](https://leetcode.com/problems/coin-change/)
		- LATER [Longest Common Subsequence](https://leetcode.com/problems/longest-common-subsequence/)
		- LATER [BST Iterator (**Bonus**)](https://leetcode.com/problems/binary-search-tree-iterator/)
	- #### LATER Week 11 - Dynamic Programming Resources
		- LATER [What is Dynammic Programming and How to Use It](https://youtu.be/vYquumk4nWw) by CS Dojo
		- LATER [5 Simple Steps for DP](https://youtu.be/aPQY__2H3tE) by Reducible
		- LATER MIT Lectures on DP (numbered 19-21)
		- LATER [Lecture 19](https://youtu.be/OQ5jsbhAv_M)
		- LATER [Lecture 20](https://youtu.be/ENyox7kNKeY)
		- LATER [Lecture 21](https://youtu.be/ocZMDMZwhCY)
		- LATER [MIT Lectures on Advanced DP](https://youtu.be/Tw1k46ywN6E)
	- ### LATER Week 12 - Dynamic Programming
		- LATER [Unique Paths](https://leetcode.com/problems/unique-paths/)
		- LATER [Jump Game](https://leetcode.com/problems/jump-game/)
		- LATER [Decode Ways](https://leetcode.com/problems/decode-ways/)
		- LATER [Longest Increasing Subsequence](https://leetcode.com/problems/longest-increasing-subsequence/)
		- LATER [Word Break](https://leetcode.com/problems/word-break/)
		- LATER [Combination Sum IV](https://leetcode.com/problems/combination-sum-iv/)
		- LATER [Max Area of Island (**Bonus**)](https://leetcode.com/problems/max-area-of-island/)
	- ### LATER Week 13 (Bonus) - Binary
		- LATER [Sum of Two Integers](https://leetcode.com/problems/sum-of-two-integers/)
		- LATER [Number of 1 Bits](https://leetcode.com/problems/number-of-1-bits/)
		- LATER [Counting Bits](https://leetcode.com/problems/counting-bits/)
		- LATER [Missing Number](https://leetcode.com/problems/missing-number/)
		- LATER [Reverse Bits](https://leetcode.com/problems/reverse-bits/)
		- LATER [Developer-Tester Integration (**Bonus**)](https://leetcode.com/discuss/interview-question/882739/Snowflake-or-Summer-2021-Internship-OA-or-Developer-Tester-Integration)
	- ### LATER Week 14 (Bonus) - Recursion and Backtracking
		- LATER [Permutations](https://leetcode.com/problems/permutations/)
		- LATER [Letter Combos of Phone Number](https://leetcode.com/problems/letter-combinations-of-a-phone-number/)
		- LATER [Sudoku Solver](https://leetcode.com/problems/sudoku-solver/)
		- LATER [Subsets](https://leetcode.com/problems/subsets/)
		- LATER [Generate Parentheses](https://leetcode.com/problems/generate-parentheses/)
		- LATER [Palindrome Partitioning](https://leetcode.com/problems/palindrome-partitioning/)
		- LATER [Flatten Nested List Iterator (**Bonus**)](https://leetcode.com/problems/flatten-nested-list-iterator/)
	- ### LATER Week 15 (Bonus) - Binary Search
		- LATER [Discussion](https://leetcode.com/discuss/general-discussion/786126/Python-Powerful-Ultimate-Binary-Search-Template.-Solved-many-problems)
		- LATER [First Bad Version](https://leetcode.com/problems/first-bad-version/)
		- LATER [Sqrt(x)](https://leetcode.com/problems/sqrtx/)
		- LATER [Search Insert Position](https://leetcode.com/problems/search-insert-position/)
		- LATER [Capacity to Ship Packages within D Days](https://leetcode.com/problems/capacity-to-ship-packages-within-d-days/)
		- LATER [Split Array Largest Sum](https://leetcode.com/problems/split-array-largest-sum/)
		- LATER [Koko Eating Bananas](https://leetcode.com/problems/koko-eating-bananas/)
		- LATER [Range Sum Query (Bonus)](https://leetcode.com/problems/range-sum-query-immutable/)
		- LATER [Range Sum Query 2d Immutable (**Bonus**)](https://leetcode.com/problems/range-sum-query-2d-immutable/)