# Leetcode Average-Salary-Excluding-the-Minimum-and-Maximum-Salary

#### 2022-07-23 15:27

> ##### Difficulty:
>
> #coding_problems #difficulty_easy
>
> ##### Additional tags:
>
> #leetcode #math
>
> ##### Revisions:
>
> N/A

##### Related topics:

##### Links:

- [Link to problem](https://leetcode.com/problems/average-salary-excluding-the-minimum-and-maximum-salary/)

  ***

### Problem

You are given an array of **unique** integers `salary` where `salary[i]` is the salary of the `ith` employee.

Return _the average salary of employees excluding the minimum and maximum salary_. Answers within `10-5` of the actual answer will be accepted.

#### Examples

**Example 1:**

**Input:** salary = [4000,3000,1000,2000]
**Output:** 2500.00000
**Explanation:** Minimum salary and maximum salary are 1000 and 4000 respectively.
Average salary excluding minimum and maximum salary is (2000+3000) / 2 = 2500

**Example 2:**

**Input:** salary = [1000,2000,3000]
**Output:** 2000.00000
**Explanation:** Minimum salary and maximum salary are 1000 and 3000 respectively.
Average salary excluding minimum and maximum salary is (2000) / 1 = 2000

#### Constraints

- `3 <= salary.length <= 100`
- `1000 <= salary[i] <= 106`
- All the integers of `salary` are **unique**.

### Thoughts

> [!summary]
> This is a #math problem

The one solution I came up with is using math.

When counting total, be warned of integer overflows.

### Solution

```cpp
class Solution {
public:
double average(vector<int> &salary) {
  double ans = 0, factor = salary.size() - 2;
  int maxSal = 0, minSal = 1000001;

  for (int i = 0, size = factor + 2; i < size; i++) {
    ans += salary[i] / factor;
    maxSal = max(maxSal, salary[i]);
    minSal = min(minSal, salary[i]);
  }
  return ans - minSal / factor - maxSal / factor;
}
};
```
