# Leetcode Binary-Tree-Postorder-Traversal

- #### 2022-07-04 21:31

  > ##### Algorithms:
  >
  > #algorithm #DFS #DFS_postorder
  >
  > ##### Data structures:
  >
  > #DS #binary_tree
  >
  > ##### Difficulty:
  >
  > #coding_problems #difficulty_easy
  >
  > ##### Additional tags:
  >
  > #leetcode #CS_list_need_practicing
  >
  > ##### Revisions:
  >
  > N/A

##### Related topics:

##### Links:

- [Link to problem](https://leetcode.com/problems/binary-tree-postorder-traversal/)

  ***

### Problem

https://leetcode.com/problems/binary-tree-postorder-traversal/

#### Examples

**Example 1:**

![](https://assets.leetcode.com/uploads/2020/08/28/pre1.jpg)

**Input:** root = [1,null,2,3]
**Output:** [3,2,1]

**Example 2:**

**Input:** root = []
**Output:** []

**Example 3:**

**Input:** root = [1]
**Output:** [1]

#### Constraints

- The number of the nodes in the tree is in the range `[0, 100]`.
- `-100 <= Node.val <= 100`

### Thoughts

Same as [[Leetcode Binary-Tree-Inorder-Traversal]] and [[Leetcode Binary-Tree-Preorder-Traversal]]

== TODO: write iteration and another algo #TODO ==

### Solution

Recursion

```cpp
/**
 * Definition for a binary tree node.
 * struct TreeNode {
 *     int val;
 *     TreeNode *left;
 *     TreeNode *right;
 *     TreeNode() : val(0), left(nullptr), right(nullptr) {}
 *     TreeNode(int x) : val(x), left(nullptr), right(nullptr) {}
 *     TreeNode(int x, TreeNode *left, TreeNode *right) : val(x), left(left),
 * right(right) {}
 * };
 */
class Solution {
void postorder(TreeNode *root, vector<int> &answer) {
  if (root == nullptr) {
    return;
  }

  postorder(root->left, answer);
  postorder(root->right, answer);
  answer.push_back(root->val);
}

public:
vector<int> postorderTraversal(TreeNode *root) {
  vector<int> answer;
  postorder(root, answer);
  return answer;
}
};

```
