- LATER 卖海底捞的锅
- [[拥抱逝水年华]] [[Book notes]]
  collapsed:: true
	- Metadata:
		- Time: 21:05
		- 章节: 九弃书不观
	- Content:
		- 弃书不观一章中，德波顿回应了我持久以来的一个困惑：我会成为书呆子吗？我该如何避免成为这样的人？简而言之：对书本的正确态度应是既能领略其妙处，又能察觉其限制。
		- 讲到书的妙处，我联想到 [[华氏451]]中的一个观点，就是其中一个角色说读书应该做到三件事：
			- 确保你有时间和精力读一本书
			- 确保你有足够的时间想这一本书
			- 确保你在读完这本书之后有一些行动
		- 此章节就部分呼应了华氏中的第三点：书不是你精神生活的全部，相反，它是用来补足你的精神生活的。爱情小说中男女主的感情再撕心裂肺一波三折，都无法代替我自己的感情经历，而相反，我用局外人的视角观察小说中的人物，能更好理解我自己的经历，从而更好地丰富我自己的生活。更加形而上的文章也应如此，我分析作者的观点将大师的功力内化，这样才能拨云见日看清之前所困扰的谜题。
		- 同时，书和其他艺术形式还有一个好处就是让我们重新看到生活中被忽略的美感。这一观点在“心胸豁然”一章也有提及。人们被“大师”被消费主义有意无意地迷惑，将别人捕捉到和塑造出来的美误认为是生活中美的全部，而生活的美不局限在什么艺术展音乐剧中，早起时听到的鸟鸣，雨后细碎的积雨云和在网上听到的演出现场一样很美，一样值得我们欣赏。
		- 而德波顿同时也提出书的限制，和什么时候该“弃书不观”。他提到尽信书本会让人们出现许多症候：
			- 视作家为神明，或者更概括地：艺术上的偶像崇拜
				- 很明显地，这样会让人们的视野局限在前人有限的创作中，而生活的美是无处不在的。一个作家好，但并不能替代世界上其他的作家，一类艺术作品中的内容能够激起你的感情，不意味着它是绝对的至味，也不意味着有其他美好的食物。而普鲁斯特也有言：“一幅画的美并不取决于它画的是什么东西”。在我看来，艺术的表达方式固然重要，但其内核依然是表现的内容：体现了人类怎样的普世问题？艺术家通过这幅画想要告诉你或给你展示什么？而画的内容，只不过是上述一切都载体。
			- 看罢好书不能停笔
				- 这个问题的来源和处方也很明显，因为我认为每个人的个人经验都是不可替代的，普鲁斯特写人的年华易逝，并不会影响白先勇写台湾人国族认同以及国民党人对于江川易主的感慨。
- [[拥抱逝水年华]] [[Book notes]]
  collapsed:: true
	- Metadata:
		- Time: 19:44
		- Page: 第八章：享受爱情
	- Content:
		- 德波顿在此章分析了爱情的两个方面：性交和吸引力
		  collapsed:: true
			- 在吸引力方面，德波顿分析指出相爱的人很容易对对方感到厌倦，吸引力会下降。原因很明显，人是习惯的动物。德波顿为了解释相爱之人在相处久后自认为双方十分了解但实际上不是的现象（参见[[亲密关系]]）引用了诺亚的例子：诺亚活了500年，看尽人间草木，但当他被关在方舟同花鸟鱼兽作伴40天，出来发现世界面目全非之后，对世间万物的怜惜之情油然而生。亲密关系也有类似的论述，在恋人正要离你而去时，你才能回想起跟她一起幸福生活的点点滴滴（除非你在此时已经变了心）。
			- 同时，德波顿也列举了维护吸引力的一些方法：
			  collapsed:: true
				- 延迟享受：德波顿举了富人和穷人的例子：富人的富算是一种诅咒，因为他想要什么立马就会得到，而得到之后很快就会厌倦，而穷人对一件商品朝思暮想，得到后更加满足，因为自己为此付出了很多努力。
				- 利用第三者：根据恋爱的三角关系理论： 欲他人之所欲，这样可以有效拉近双方的距离。我个人认为这种方式有可能玩过火，其他维护吸引力的方法可参见[[亲密关系]]
			- 在性交方面，普鲁斯特解答了一个中国人很爱问的问题：是否支持婚前性行为。在他的观念里，性行为是为了爱情而服务的。跟上述关于吸引力的论述一样，性行为同样是和“延迟享受”紧密相连的，他指出男人嫖娼不可取，原因有二：
			  collapsed:: true
				- 一方面是因为和良家妇女不同，妓女为了营业不可能拒绝，你从和妓女性交中得到的快感并不能持续。
				- 第二方面也是我认为更重要的方面：嫖客以为自己从性交中得到了爱情，但很明显这只是对于爱情的幻觉。而像这样从射精到感觉到“爱”的条件反射反而会抑制一个人对真正爱情的追求。他会被这个幻象迷惑，认为自己不满足是因为性能力不够，对方不配合，但实际上不满足的结果更指向问题本身：想要从嫖娼中得到爱情。
			- 尽管我不嫖娼，德波顿这里关于嫖娼的叙述依然值得我深思，它反映的是资本主义社会中现代人的“代餐”文化：用高潮代替爱情，用披着教育性外壳的娱乐视频代替深度的系统性的学习，用肤浅的消费主义代替幸福。应该常常质问自己：这（自慰、看油管视频、暴食、冲动消费）是不是我真正想要的？
-
- Daily reflection [[Daily reflections]]
  collapsed:: true
	- What I've done
		- 军训
		- 花一晚上读书和写读书笔记
	- What I've thought #thoughts
		- 写读书笔记是真的能促进专注力，一坐下去一晚上就没了
		- LATER 今天主要是比较累，而且没想到写读书笔记能这么认真，每日任务没做什么，所以明天一早就要去把每日任务做了。
		  SCHEDULED: <2023-04-23 Sun>
	- Mood
		- 挺开心的反正
-
- 书籍元数据:
  template:: 书籍元数据
  collapsed:: true
	- 作者：
	- 阅读时间：
	- 评分：? / 5
		- 评价内容