- [[学习任务]]
	- Test timetable
		- ![2023-06-09-13-21-19.jpeg](../assets/2023-06-09-13-21-19.jpeg)
-
- Daily reflection [[Daily reflections]]
	- What I've done
		- Morning: Workout
		- Afternoon: Review [[产品开发]] and [[数据库]]
		- Night: Review [[Java]]
	- What I've thought #thoughts
	- Mood
-
- [[产品开发]]
	- ## Topic 6 - 10
	  collapsed:: true
		- ### Topic 6 - Phase 1: Concept Development 概念开发
			- What is Concept Development? 概念开发是什么
				- The needs of the target market are identified
				  Alternative product concepts are generated and
				  evaluated 需求
				  One or more concepts are selected for further
				  development and testing 多种概念被生成，经过挑选后选择其中一个
				  A concept is a description of the form, function
				  and features of a product 概念是一个产品的描述，功能和特性
				  Evaluation and screening criteria are used to aid
				  in the selection 评估和测试可以辅助选择（screen = test）
				  Usually accompanied by a set of specifications, an
				  analysis of competitive products and an economic
				  justification for the project 伴随着来自个方面的要求，与竞争对手的比较和分析，还有经济方面的考虑（能不能赚钱）
				- This can be concluded as 图解如下
				- ![image.png](../assets/image_1686289806889_0.png)
			- #### Identify Customer Needs 用户需求是什么
				- to understand customers needs, 
				  then to effectively communicate them to the
				  development team 和研发队伍沟通
				  The output of this step is:
				  Customer need statements organised in a
				  hierarchical list, with importance weightings
				  for many or all of the needs 把用户的需求整理成加权列表
			- #### Establishing target specifications 确立规格要求
				- 1. Prepare the list of metrics, i.e. the technical or
				  manufacturing features of the product based on
				  the customer needs 准备一些数据的列表
				- 2. Collect competitive benchmarking information 竞争对手的产品性能
				- 3. Set ideal and marginally acceptable target values 理想的和可接受的要求
				- 4. Reflect on the results and the process 通过结果和进一步完善
			- #### Concept generation 想一个概念
				- Steps:
					- external search 在外面搜索
					- creative problem solving within the team, and 团队灵机一动
					- systematic exploration of the various solution
					  fragments the team generates 系统地寻找解决方法
				- The result of this activity is usually a set of 10-20
				  concepts – each is typically represented by a sketch
				  and a brief descriptive text 产生10-20个概念
				- ![image.png](../assets/image_1686289726119_0.png)
			- #### Concept selection 选一两个出来
				- the activity in which various
				  product concepts are analysed and sequentially
				  eliminated to identify the most promising
				  concept(s)
				- ![image.png](../assets/image_1686289907417_0.png){:height 564, :width 688}
				- There are 5 stages to the screening and
				  evaluation process: 用以下方式选择好的概念
					- 1. Initial screen - The key evaluation criteria given in the table on the
					  previous slides can be developed further using a
					  scoring model or weighted checklist 用之前的要求测试
					- 2. Customer screen - An informal discussion with customers to
					  explain a concept 和客户沟通
					- 3. Technical screen 在科技实现上咨询第一方和第三方的专家
						- informal technical discussions with experts
						- extensive analysis by a 3 rd party
					- 4. Final screen 最终测试
						- Involves the use of screening models and computer assessment programs
					- 5. Business analysis 看下赚不赚钱
						- preliminary marketing plans,
						- technical plans,
						- financial reviews and
						- projected budgets
			- #### Concept testing 测试
				- There are 7 steps to this process
					- 1. Define the purpose of the concept test 定义测试的目的
					- 2. Choose a survey population 选问卷调查的目标对象
					- 3. Choose a survey format 格式
					- 4. Communicate the concept 和目标对象沟通这个概念
					- 5. Measure customer response 客户怎么想
					- 6. Interpret the results 分析结果
					- 7. Reflect on the results and process 用结果改进
			- #### Setting final specifications 最终规格
			             Target specifications are revisited after a concept has been selected and tested
			- #### Project planning 计划
				- The final activity of concept development
				- Steps:
					- creates a detailed development schedule 产品开发时间线
					- devises a strategy to minimise development time and 定一个计划
					- identifies the resources required to complete the project 需求是什么
			- #### Economic analysis
				- 拿出去卖亏不亏钱
			- #### Benchmarking & modelling
				- 和竞争对手比较，品质行不行
	- 往年题考点
		- Prototypes (2019
			- Physical prototype, (5 marks) (2019
			- Analytical prototype, (5 marks) (2019
			- Comprehensive prototype. (5 marks) (2019
		- Costs (2019
			- Component costs, (5 marks) (2019
			- Support costs, (5 marks) (2019
			- Indirect allocations as part of Overhead costs. (5 marks) (2019
		- New products and New product development (2019
			- Booz, Allen & Hamilton (1982) Classification Scheme (2019
				- Repositioning (4 marks) (2019
				- four (4) elements through which products can be differentiated (2019
                - the five alternatives that are open to the firm ( 2018
                - kinds of new products identified by Booz Allen and Hamilton ( 2018
                - four elements where values can be added to the basic or ‘core’ product to augment its appeal ( 2018
			- Product life cycle (2019
            - prototyping ( 2018
                - three phases of prototyping ( 2018
                - uses of prototypes ( 2018
		- system-level design (2019
			- product architecture (2019
			- key characteristics of modular and integral architecture. (2019
			- three (3) main types of modular architecture. (2019
        - IP (
            - the concept (
            - what sort of intellectual property copyright can protect and what form of protection it gives. (
            - benefits and limitations of using patents (
