- Daily reflection [[Daily reflections]]
  id:: 64856c09-6826-4ed3-b21e-380d43ea95a6
  - What I've done
    - 上午看[[学交]]，写[[数据库]]题
  - What I've thought #thoughts
  - Mood
-
- [[产品开发]]
  - ## Topic 7: Innovation
    id:: 64857305-2925-485f-9aed-e15511b42149
    collapsed:: true
    - ### Definition of Innovation
      Innovation is the process of creating something new that adds value to society. It can involve developing new products, services, processes, or business models. Innovation can be driven by a variety of factors, such as technological advances, changes in consumer preferences, or shifts in the competitive landscape.
    - ### Types of Innovation
      collapsed:: true
      There are different types of innovation, including:
      - Radical innovation: involves creating something entirely new that disrupts existing markets or creates new ones.
      - Incremental innovation: involves making small improvements to existing products or processes.
      - Disruptive innovation: involves creating a new product or service that initially serves a niche market but eventually disrupts the existing market.
      - Sustaining innovation: involves making improvements to existing products or processes that help maintain a company's competitive position.
    - ### Models of Innovation
      collapsed:: true
      Innovation can follow different models, such as:
      - Linear model: involves a sequential process of research, development, and commercialization.
      - Cyclical model: involves a continuous process of feedback and iteration.
      - Open innovation: involves collaborating with external partners to develop new products or services.
    - ### Characteristics of Innovative Companies
      collapsed:: true
      Innovative companies share certain characteristics, such as:
      - A willingness to take risks and experiment with new ideas.
      - A focus on customer needs and preferences.
      - A culture that encourages creativity, collaboration, and learning.
      - A commitment to continuous improvement and innovation.
    - ### Strategies for Fostering a Culture of Innovation
      collapsed:: true
      Companies can foster a culture of innovation by:
      - Providing resources, such as funding, time, and expertise, to support innovation initiatives.
      - Encouraging collaboration and cross-functional teams.
      - Rewarding creativity and risk-taking.
      - Creating a supportive and inclusive work environment.
    - ### Examples of Innovative Companies and Products
      collapsed:: true
      There are many examples of innovative companies and products, such as:
      - Apple: known for its innovative products, such as the iPhone and iPad.
      - Tesla: known for its innovative electric vehicles and renewable energy solutions.
      - Sinclair C5: an innovative electric vehicle developed in the 1980s that was ahead of its time.
    - ### Further Resources
      The PDF provides links to further resources for learning about innovation, such as a video and short videos about new inventions. These resources can help individuals and companies stay up-to-date on the latest trends and developments in innovation and product development.
  - ## Topic 7 PDF 概述
    collapsed:: true
    本 PDF 文件提供了创新和产品开发的概述。它涵盖了创新的基本原则、创新的类型、创新的模型以及什么使一个创新型公司。
    - ## 涵盖的主题
      collapsed:: true
      - 创新的定义
      - 创新的类型（根本性、渐进性、破坏性、维持性）
      - 创新的模型（线性、循环、开放式创新）
      - 创新型公司的特点
      - 培养创新文化的策略
      - 创新型公司和产品的例子
      - 进一步阅读的资源（包括一个视频和关于新发明的短视频）
    - ## 主要观点
      collapsed:: true
      - 创新是创造新的、对社会有价值的东西的过程。
      - 有不同类型的创新，包括根本性、渐进性、破坏性和维持性。
      - 创新可以遵循不同的模型，如线性、循环或开放式创新。
      - 创新型公司共享某些特点，如愿意冒险、关注客户需求和鼓励实验和学习的文化。
      - 公司可以通过提供资源、鼓励协作和奖励创造力来培养创新文化。
      - 创新型公司和产品的例子包括苹果、特斯拉和辛克莱 C5 电动车。
      - 进一步了解创新的资源包括一个视频和关于新发明的短视频。
    - ### 创新的定义
      创新是创造新的、对社会有价值的东西的过程。它可以涉及开发新产品、服务、流程或商业模式。创新可以由各种因素驱动，如技术进步、消费者偏好的变化或竞争格局的转变。
    - ### 创新的类型
      collapsed:: true
      有不同类型的创新，包括：
      - 根本性创新：涉及创造全新的东西，打破现有市场或创建新市场。
      - 渐进性创新：涉及对现有产品或流程进行小幅改进。
      - 破坏性创新：涉及创建一个最初服务于利基市场但最终打破现有市场的新产品或服务。
      - 维持性创新：涉及对现有产品或流程进行改进，以帮助维持公司的竞争地位。
    - ### 创新的模型
      collapsed:: true
      创新可以遵循不同的模型，如：
      - 线性模型：涉及研究、开发和商业化的顺序过程。
      - 循环模型：涉及反馈和迭代的持续过程。
      - 开放式创新：涉及与外部合作伙伴合作开发新产品或服务。
    - ### 创新型公司的特点
      collapsed:: true
      创新型公司共享某些特点，如：
      - 愿意冒险和尝试新想法。
      - 关注客户需求和偏好。
      - 鼓励创造力、协作和学习的文化。
      - 致力于持续改进和创新。
    - ### 培养创新文化的策略
      collapsed:: true
      公司可以通过以下方式培养创新文化：
      - 提供资源，如资金、时间和专业知识，支持创新项目。
      - 鼓励协作和跨职能团队。
      - 奖励创造力和冒险精神。
      - 创造一个支持性和包容性的工作环境。
    - ### 创新型公司和产品的例子
      collapsed:: true
      有许多创新型公司和产品的例子，如：
      - 苹果：以其创新产品，如 iPhone 和 iPad 而闻名。
      - 特斯拉：以其创新的电动汽车和可再生能源解决方案而闻名。
      - 辛克莱 C5：一款在 1980 年代开发的创新电动车，领先于其时代。
    - ### 进一步资源
      本 PDF 文件提供了进一步了解创新的资源链接，如一个视频和关于新发明的短视频。这些资源可以帮助个人和公司了解创新和产品开发的最新趋势和发展。
  - ## Topic 8: Digital Transofrmation and Digital Products
    id:: 64857305-a186-4927-890d-607f66d97f95
    collapsed:: true
    - Digital Transformation
      collapsed:: true
      - Terms
        collapsed:: true
        - **Digitisation** is the process of converting information from analog to digital.
        - **Digitalisation** is the process of using digitised information to make established ways of working simpler and more efficient.
        - **Digital transformation** is the process of using digital technologies to create new — or modify existing — business processes, culture, and customer experiences to meet changing business and market requirements
      - **Types** of Digital transformation
        collapsed:: true
        - **Process Transformation** – aims to process such as data, analytics, AI, and any process that can work towards lowering costs and driving operational efficiency in the business.
        - **Business Model Transformation** – aims to make fundamental changes in how a business or organization runs which can include personnel, processes, and technology.
        - **Domain Transformation** - This area offers a great opportunity to move into a new domain or area that a business may not have explored before by acquiring new technologies.
        - **Cultural/Organizational Transformation** -
          This is about redefining mindsets, processes, capabilities and skills for a digital world. It’s about driving digital transformation forward through growth initiatives that are grounded in a new culture and way of thinking.
      - **Guidelines** for a successful Digital
        collapsed:: true
        Transformation
        - Understand your technology
        - Embrace Cultural Change
        - Consider a new digital business model
        - Digital upskilling
        - Ensure Collaboration
        - Top Management Support
    - Digital Product
      collapsed:: true
      - Characteristics
        collapsed:: true
        - no physical form, exist only in the digital realm,
        - _intangible_ items delivered _electronically_,
        - anything that can be _downloaded_ and _used digitally_ can be considered a digital product,
        - sold online or through brick-and-mortar retailers,
        - can be easily updated or modified to keep up with changing technology and trends because they're intangible,
        - often come with a license that allows a customer to use them in unlimited ways.
      - Will everything become digital?
        collapsed:: true
        - In practice, most products and experiences they are part of are _hybrid_.
      - **Why** digital products?
        collapsed:: true
        - Customer happiness is how you win in business. Modern customer expectations are being driven by largely digital technology and digital innovations.
        - Low investment, (potentially) high returns
        - More profitable than physical goods
        - No inventory, shipping or rent hassle
        - Automated delivery for passive income
        - Serve a niche at scale
        - Digital products offer unique ways to communicate directly with the customers.
    - Digital Project Development
      collapsed:: true
      - Phase 1. **Discovery**: the process of identifying the problem to be
        solved, making sure the problem is worth solving, and
        envisioning the solution to that problem.
      - Phase 2. **Ideate**: The goal is to brainstorm possible solutions to the
        problem identified in the discovery phase, creating a
        strategy for how to build a product that will solve that
        problem.
      - Phase 3. **Test**: The testing phase is all about gathering data,
        refining and improving your idea, and gathering more data
        until you have a sharp idea. The testing phase should
        involve at least four steps, known as the lean validation
        process
      - Phase 4. **Execute**: This stage aims to develop the“most
        valuable player” namely the _Minimum Viable
        Product (MVP)._
      - Phase 5. **Launch**: Once your MVP is ready to go, it’s time to launch. A
        digital product launch usually means putting the MVP
        on the market and giving customers their first crack at
        your solution.
      - Phase 6. **Grow**: As refine the digital product into its final form, based on
        the feedback from the MVP launch, it’s time to consider
        the growth or scaling phase.
    - Digital Project Management
      collapsed:: true
      - Terms
        collapsed:: true
        - **Digital Project Manager**: the glue that brings
          together many facets of a successful digital product—
          customers, design, engineering, operations, sales,
          marketing, finance, compliance, legal, and more.
        - **Project Team for Digital Products**:
          collapsed:: true
          A project team for digital product is made up of:
          - **Developers or engineers** – the people who will code, test and deploy the digital application that will be used by customers.
          - **Experts in customer or user experience** who focus on how the product and associated services will be used by the customer, and who create the user interface, services and other interactions with the customers
          - **Sales and marketing experts**, who will actually get customers to use the product.
      - mistakes to avoid
        collapsed:: true
        - Having the _wrong data_
        - _Resistance_ from staff
        - Underestimate _costs_
        - A lack of _commitment_
        - A lack of _skills_
  - ## 主题 8
    collapsed:: true
    - 数字化转型
      collapsed:: true
      - 术语
        collapsed:: true
        - **数字化** 是将信息从模拟形式转换为数字形式的过程。
        - **数字化** 是利用数字化的信息使现有的工作方式更简单、更高效的过程。
        - **数字化转型** 是利用数字技术来创建新的或修改现有的业务流程、文化和客户体验，以满足不断变化的业务和市场需求的过程。
      - 数字化转型的**类型**
        collapsed:: true
        - **流程转型** - 旨在通过数据、分析、人工智能以及任何可以降低成本并提高业务运营效率的流程来实现。
        - **商业模式转型** - 旨在对企业或组织的运营进行根本性改变，包括人员、流程和技术。
        - **领域转型** - 这个领域为企业提供了进入新领域或领域的机会，通过获取新技术来实现。
        - **文化/组织转型** - 这涉及到重新定义数字世界中的思维方式、流程、能力和技能。通过以新的文化和思维方式为基础的增长举措，推动数字化转型的进程。
      - 实现成功数字化转型的**指南**
        collapsed:: true
        - 了解您的技术
        - 接受文化变革
        - 考虑新的数字商业模式
        - 数字技能提升
        - 确保合作
        - 高层管理支持
    - 数字产品
      collapsed:: true
      - 特点
        collapsed:: true
        - 无实体形态，只存在于数字领域
        - *无形*产品通过*电子方式*交付
        - 任何可以*下载*和*数字使用*的物品都可以被视为数字产品
        - 在线销售或通过实体零售商销售
        - 可以轻松更新或修改以跟上技术和趋势的变化，因为它们是无形的
        - 通常附带许可证，允许客户以无限的方式使用它们
      - 所有事物都会变成数字吗？
        collapsed:: true
        - 实际上，大多数产品和体验都是*混合型*的。
      - **为什么**选择数字产品？
        collapsed:: true
        - 客户的幸福感是赢得业务的关键。现代客户的期望主要受数字技术和数字创新的推动。
        - 投资低，（可能）回报高
        - 比实体商品更具盈利能力
        - 无需库存、物流或租金麻烦
        - 自动化交付实现被动收入
        - 以规模服务于细分市场
        - 数字产品提供了与客户直接沟通的独特方式。
    - 数字项目开发
      collapsed:: true
      - 第一阶段 **发现**：识别待解决的问题，确保问题值得解决，并构想解决问题的方案。
      - 第二阶段 **构思**：目标是对发现阶段确定的问题进行头脑风暴，创建构建解决该问题的产品的策略。
      - 第三阶段 **测试**：测试阶段涉及收集数据、完善和改进您的想法，并收集更多数据，直到您拥有一个清晰的想法。测试阶段应包括至少四个步骤，即精益验证过程。
      - 第四阶段 **执行**：这个阶段旨在开发最有价值的产品，即*最小可行产品 (MVP)*。
      - 第五阶段 **发布**：一旦您的 MVP 准备就绪，就可以发布了。数字产品的发布通常意味着将 MVP 推向市场，让客户首次体验您的解决方案。
      - 第六阶段 **增长**：在根据 MVP 发布的反馈对数字产品进行最终形态的改进时，是考虑增长或扩展阶段的时候。
    - 数字项目管理
      collapsed:: true
      - 术语
        collapsed:: true
        - **数字项目经理**：他们将许多方面成功地融合在一起，包括客户、设计、工程、运营、销售、市场营销、财务、合规性、法律等等。
        - **数字产品项目团队**：数字产品项目团队由以下成员组成：
          collapsed:: true
          - **开发人员或工程师** - 负责编码、测试和部署将由客户使用的数字应用程序的人员。
          - **用户体验专家** - 关注产品和相关服务如何被客户使用，并创建与客户的界面、服务和其他交互。
          - **销售和市场营销专家** - 将实际使客户使用产品。
      - 需要避免的错误
        collapsed:: true
        - 使用*错误的数据*
        - 员工*抵触*
        - 低估*成本*
        - 缺乏*承诺*
        - 缺乏*技能*
  - ## Topic 2: Project Management
    id:: 648581e7-cc5c-4514-9c2a-0b6af4adc5bb
    collapsed:: true
    - **Define** what is project management
      collapsed:: true
      - For all but the simplest products, product development involves many people completing many different tasks.
      - is the activity of planning and coordinating resources and tasks to achieve these goals.
    - Two Phases of **PM**
      collapsed:: true
      - Project planning involves scheduling the project tasks and determining resource requirements. The project plan is first laid out during the concept development phase, although it is a dynamic entity and continues to evolve throughout the development process.
      - Project execution, sometimes called project control, involves coordinating and facilitating the myriad tasks required to complete the project in the face of inevitable unanticipated events and the arrival of new information. Execution is just as important as planning; Many teams fail because they do not remain focused on their goals for the duration of the project.
    - **Project Planning**: Understand and represent different tasks in projects
      collapsed:: true
      - Sequential, Parallel, and Coupled Tasks
        collapsed:: true
        - ![image.png](../assets/image_1686471430664_0.png)
      - The Design Structure Matrix
        collapsed:: true
        - **Definition**: A useful tool for representing and analysing
          task dependencies is the design structure matrix
          (DSM).
        - Working:
          collapsed:: true
          - A project task is assigned to a row and a corresponding column.
          - The rows and columns are named and ordered identically, although generally only the rows list the complete names of the tasks. Each task is defined by a row of the matrix.
          - We represent a task’s dependencies by placing marks in the columns to indicate the other tasks (columns) on which it depends.
          - ![image.png](../assets/image_1686471695984_0.png)
          - Reading across a row reveals all of the tasks whose output is required to perform the task corresponding to the row.
          - Reading down a column reveals which tasks receive information from the task corresponding to the column.
          - The diagonal cells are usually filled in with dots or the task labels, simply to separate the upper and lower triangles of the matrix and to facilitate tracing dependencies.
      - Gantt Chart
        collapsed:: true
        - Features:
          collapsed:: true
          - Gantt charts show how the work is broken down into a set of activities
          - They show the scheduling of these activities as a series of horizontal bands against a series of vertical lines representing dates
          - ![image.png](../assets/image_1686471844454_0.png)
          - They can be used to show dependencies between activities
          - They can be used to measure progress on a project or compare planned production with actual production
      - PERT Charts
        collapsed:: true
        - PERT (program evaluation and review technique) charts explicitly represent both dependencies and timing, in effect combining some of the information contained in the DSM and Gantt chart.
        - ![image.png](../assets/image_1686471880938_0.png)
      - The Critical Path
        collapsed:: true
        - The _dependencies_ among the tasks in a PERT chart, some of which may be arranged sequentially and some of which may be arranged in parallel, lead to the concept of a critical path.
        - The _critical path_ is the longest chain of dependent events. This is the single sequence of tasks whose combined required times define the minimum possible completion time for the entire set of tasks.
    - Undertake a baseline project plan
      collapsed:: true
      - **Definition**: project plan is the roadmap for the remaining development effort. The plan is important in coordinating the remaining tasks and in estimating the required development resources and development time.
    - Do project scheduling
      collapsed:: true
      - Methods:
        collapsed:: true
        - Contract Book
        - Project Task List
        - Team staffing & Organisation
        - Project Schedule
        - Project Budget
        - Project Risk Plan
        - Modifying the baseline plan
    - Accelerate projects
      collapsed:: true
      - Product development time is often the dominant concern in project planning and execution. There are a set of guidelines for accelerating product development projects.
    - **Execute** projects
      collapsed:: true
      - Smooth execution of even a well-planned project requires careful attention. Three problems of project execution are particularly important: 1. What mechanisms can be used to coordinate tasks? 2. How can project status be assessed? and 3. What actions can the team take to correct for undesirable deviations from the project plan?
  - ## 主题 2
    collapsed:: true
    - **定义** 什么是项目管理
      collapsed:: true
      - 对于除了最简单的产品以外，产品开发涉及到许多人完成许多不同的任务。
      - 项目管理是规划和协调资源和任务以实现这些目标的活动。
    - **PM** 的两个阶段
      collapsed:: true
      - 项目规划涉及安排项目任务并确定资源需求。项目计划首先在概念开发阶段制定，尽管它是一个动态实体，并在整个开发过程中不断演变。
      - 项目执行，有时称为项目控制，涉及协调和促进完成项目所需的各种任务，面对必然发生的意外事件和新信息的到来。执行与规划同样重要；许多团队失败是因为在整个项目的持续时间内没有保持对目标的专注。
    - **项目规划**：理解和代表项目中的不同任务
      collapsed:: true
      - 顺序、并行和耦合任务
        collapsed:: true
        - ![image.png](../assets/image_1686471430664_0.png)
      - 设计结构矩阵
        collapsed:: true
        - **定义**：用于表示和分析任务依赖关系的有用工具是设计结构矩阵（DSM）。
        - 工作原理：
          collapsed:: true
          - 一个项目任务分配给一行和相应的列。
          - 行和列的命名和顺序相同，尽管通常只有行列出任务的完整名称。每个任务由矩阵的一行定义。
          - 我们通过在列中放置标记来表示任务的依赖关系，以指示其所依赖的其他任务（列）。
          - ![image.png](../assets/image_1686471695984_0.png)
          - 横向读取一行可以看到所有需要完成与该行对应任务相关的任务的输出。
          - 纵向读取一列可以看到哪些任务接收来自与该列对应的任务的信息。
          - 对角线的单元格通常填充有点或任务标签，仅用于分隔矩阵的上三角形和下三角形，并便于追踪依赖关系。
      - 甘特图
        collapsed:: true
        - 特点：
          collapsed:: true
          - 甘特图展示了工作如何被分解为一系列活动。
          - 它们以一系列垂直线表示日期，以一系列水平带表示这些活动的调度。
          - ![image.png](../assets/image_1686471844454_0.png)
          - 它们可以用于显示活动之间的依赖关系。
          - 它们可以用于衡量项目的进展或比较计划生产与实际生产情况。
      - PERT 图
        collapsed:: true
        - PERT（程序评估和审查技术）图明确表示依赖关系和时间，实际上结合了 DSM 和甘特图中包含的一些信息。
        - ![image.png](../assets/image_1686471880938_0.png)
      - 关键路径
        collapsed:: true
        - PERT 图中任务之间的依赖关系，其中一些可能按顺序安排，一些可能并行安排，导致关键路径的概念。
        - 关键路径是最长的一系列依赖事件。这是一系列任务的单一序列，其组合所需的时间定义了整个任务集合的最短可能完成时间。
    - 进行基准项目计划
      collapsed:: true
      - **定义**：项目计划是剩余开发工作的路线图。该计划在协调剩余任务和估计所需的开发资源和开发时间方面非常重要。
    - 进行项目调度
      collapsed:: true
      - 方法：
        collapsed:: true
        - 合同书
        - 项目任务列表
        - 团队配备和组织
        - 项目进度表
        - 项目预算
        - 项目风险计划
        - 修改基准计划
    - 加速项目
      collapsed:: true
      - 产品开发时间通常是项目规划和执行中最主要的关注点。有一套加速产品开发项目的指南。
    - **执行** 项目
      collapsed:: true
      - 即使是一个精心计划的项目，顺利执行也需要仔细注意。项目执行的三个重要问题是：
        1.  可以使用哪些机制来协调任务？
        2.  如何评估项目状态？
        3.  团队可以采取哪些行动来纠正与项目计划不符的不良偏差？
  - ## Topic 3: Opportunity Identification
    collapsed:: true
    - Opportunity, definition and types
      - Definition:
        - an idea for a new product
        - It is a product description in an embryonic form
          - a newly sensed need,
          - a newly discovered technology,
          - a rough match between a need and a possible solution
        - It can be thought of as a hypothesis about how value might be created
      - Type
        - Ansoff’s growth matrix
          ![image.png](../assets/image_1686473366617_0.png)
        - Market penetration
          logseq.order-list-type:: number
          - **Opportunities** can exist within a business’s existing
            markets through increasing the volume of sales
            of existing products
        - market development
          logseq.order-list-type:: number
          - **Opportunities** are said to exist for a business’s
            products through making them available to new
            markets
            - e.g. using existing products in new
              geographical markets
            - e.g. selling your existing products to a new age
              group of customers
        - product development
          logseq.order-list-type:: number
          - **Opportunities**: offering new or improved products to
            logseq.order-list-type:: number
            existing markets
        - diversification
          logseq.order-list-type:: number
          - **Opportunities**: Moving into new markets, potentially with a base
            logseq.order-list-type:: number
            from your existing product knowledge or
            diversification through acquisition of other
            companies
        - Risk
          - The element of risk _increases the further the strategy moves away from known quantities_ the existing product and the existing market
          - **Product development** (requiring, in effect, a new product) and market extension (a new market) involve a greater risk than market penetration
          - **Diversification** (both new products and new markets) generally carries the greatest risk of all
    - Opportunity identification process
      - Establish **a charter**
        - A **charter** articulates **the goals of the organisation**
          (in relation to NPD) and establishes the **boundary
          conditions for an innovation effort.** Charters can be
          termed as mission statement for a new product.
      - Generate and sense **many opportunities**
        - Focus has to be both on **internal** and **external** sources of raw opportunities. Some of these are generated:
          - Internally
            - R&D department
          - Externally
            - customer
            - competitive product
            - sales forces
            - collab. with universities
            - investors
            - distribution partners
            - other partner companies
        - Sense opportunities: Where do they come from?
          - Passively
          - Proactively
            - Document **frustrations** and **complaints** that current **customers** experience with existing products
            - Interview lead users, with attention devoted to
              - **innovations** by these users and
              - **modifications** these users may have
                made to existing products
            - **trends**
            - Systematically gather suggestions from **current customers**
            - **Competitors**
            - **Transfer** emerging tech.
      - **R&D**: _Research_ and _Development_
        - **Definition**: to develop new knowledge and apply scientific or engineering knowledge to connect the knowledge in one field to that in others
        - Roles:
          - **Discovering and developing** new technologies Improving understanding of the technology in existing products
          - **Improving and strengthening** understanding of technologies used in manufacturing
          - **Understanding research results** from universities and other research institutions
        - Areas:
          - R&D for existing businesses
          - R&D for new businesses
          - R&D for exploratory research
      - **Screen** opportunities
        - Purpose:
          - to eliminate any opportunities that are **unlikely to result in the creation of value**,
          - to focus attention on the opportunities **worthy of further investigation**
          - **not to** pick the _single best opportunity_!
        - Approach:
          - Web-based **surveys**
          - Workshops with **multi-voting**: collaborative sessions or meetings where participants engage in a voting process to prioritize or make decisions on various options or ideas.
      - Develop **promising opportunities**
        - Details
          - customer interviews,
          - testing of existing products,
          - concept generation,
          - quick prototypes,
          - estimates of market sizes and growth rates.
        - Goal
          - resolve the greatest uncertainty surrounding each one at the lowest cost in time and money.
      - Select **exceptional opportunities**
        - Goal
          - select a few that warrant a significant investment in product development.
        - Approach:**Real-Win-Worth-it**
          - **Real**: Is the opportunity real?
          - **Win**: Can you win with this opportunity?
          - **Worth** It: Is it worth doing?
      - **Reflect** on the result and process.
        Ask the following questions:
        - **How many** of the opportunities identified came from internal sources versus external sources?
        - Did we consider **dozens or hundreds** of opportunities?
        - Was the innovation charter **too narrowly focused**?
        - Were our filtering criteria **biased**, or largely based on the best possible estimates of eventual product success?
        - Are the resulting opportunities **exciting** to the team?
    -
  - ## 主题 3：机会识别
    collapsed:: true
    - 机会的定义和类型
      - 定义：
        - 一种新产品的构想
        - 它是一个初步形式的产品描述
          - 新发现的需求
          - 新发现的技术
          - 需求和可能解决方案之间的初步匹配
        - 可以将其视为关于如何创造价值的假设
      - 类型
        - 安索夫增长矩阵
          ![image.png](../assets/image_1686473366617_0.png)
        - 市场渗透
          - **机会**存在于企业现有市场中，通过增加现有产品的销售量来实现
        - 市场开发
          - 通过将产品面向新市场使得**机会**出现于企业的产品中
            - 例如，在新的地理市场中使用现有产品
            - 例如，将现有产品销售给新的客户群体
        - 产品开发
          - **机会**：向现有市场提供新产品或改进的产品
        - 多元化
          - **机会**：进入新市场，可能基于现有产品知识或通过收购其他公司进行多元化
        - 风险
          - 风险元素与策略偏离已知量（现有产品和现有市场）的程度成正比
          - 与市场渗透相比，**产品开发**（实际上需要新产品）和市场扩展（新市场）涉及更大的风险
          - **多元化**（新产品和新市场）通常带有最大的风险
    - 机会识别过程
      - 制定**章程**
        - **章程**表达了组织（与 NPD 有关）的目标，并为创新工作设定了边界条件。章程可以被视为新产品的使命陈述。
      - 生成和发现**众多机会**
        - 需要关注内部和外部的机会来源。其中一些是通过以下方式生成的：
          - 内部生成
            - 研发部门
          - 外部生成
            - 客户
            - 竞争产品
            - 销售团队
            - 与大学合作
            - 投资者
            - 分销合作伙伴
            - 其他合作伙伴公司
        - 感知机会：它们从何而来？
          - 被动感知
          - 主动感知
            - 记录现有产品的当前客户所经历的**挫折**和**投诉**
            - 与领先用户进行访谈，关注这些用户的**创新**以及他们对现有产品的**修改**
            - 趋势
            - 系统地收集来自**现有客户**的建议
            - **竞争对手**
            - **转移**新兴技术
      - **研究与开发（R&D）**
        - **定义**：开发新知识并应用科学或工程知识，将一领域的知识与其他领域相连接
        - 角色：
          - **发现和开发**新技术，提高对现有产品中技术的理解
          - 改进和加强对制造中使用技术的理解
          - 理解来自大学和其他研究机构的研究结果
        - 领域：
          - 现有业务的研发
          - 新业务的研发
          - 探索性研究的研发
      - **筛选**机会
        - 目的：
          - 淘汰不太可能创造价值的机会
          - 将注意力集中在值得进一步调查的机会上
          - 不是选择*最佳机会*！
        - 方法：
          - 基于网络的调查
          - 带有**多元投票**的工作坊：参与者进行投票以对各种选项或想法进行优先排序或决策的协作会议或会议。
      - 开发**有前途的机会**
        - 细节：
          - 客户访谈
          - 对现有产品进行测试
          - 概念生成
          - 快速原型
          - 估计市场规模和增长率
        - 目标：
          - 以最低的时间和金钱成本解决每个机会周围最大的不确定性
      - 选择**杰出的机会**
        - 目标：
          - 选择几个值得在产品开发中进行重大投资的机会
        - 方法：**真实-胜利-值得**
          - **真实**：机会是真实的吗？
          - **胜利**：能够赢得这个机会吗？
          - **值得**：值得去做吗？
      - **反思**结果和过程。
        提出以下问题：
        - 机会识别中有多少机会来自内部来源和外部来源？
        - 我们是否考虑了数十个还是数百个机会？
        - 创新章程是否过于狭隘？
        - 我们的筛选标准是否存在偏见，或者主要基于对最终产品成功的最佳估计？
        - 结果的机会是否激发团队的激情？
  - ## Topic 5: Identify Customer Needs (Preliminary of Concept Development)
    - **Market Research** for NPD (New Product Development)
      collapsed:: true
      - **Definition**: the function that links the consumer, customer
        and public to the marketer through information
        – information used
      - **Goal**:
        - to identify and define marketing opportunities and problems;
        - to generate, refine and evaluate marketing actions;
        - to monitor marketing performance;
        - to improve understanding of the marketing process
      - When to use it?
        ![image.png](../assets/image_1686475631266_0.png)
    - **Gather** raw **data** from customers
      logseq.order-list-type:: number
      - **Interviews**: One or more development team members discuss with a single customer
      - **Focus groups**: A moderator facilitates a two-hour discussion with a group of 8 or 12 customers
      - **Observing** the product in use
      - **Surveys**: direct mail or web-based questionnaires;
    - **Interpret** the raw **data** in terms of customer needs
      logseq.order-list-type:: number
      - The data gathered in Step 1 then has to be used to
        express the customers’ needs in terms of what the
        product has to do, not in terms of how it might do
      - Use positive, not negative phrasing
      - Express the needs as attributes of the product
    - Organize **the needs** into a hierarchy of needs
      logseq.order-list-type:: number
      - Structure the needs into
        - Must-haves – “I wont buy without”
        - Delighters – “What an unexpected treat”
        - Linear Satisfiers – “The more the merrier”
        - Neutrals – “No big deal”
          This is the Kano classification
          Consumer needs can be very elusive
          Intuitions are often wrong
    - Establish the **relative importance** of the needs
      logseq.order-list-type:: number
      - Measuring preference is central to market research
    - **Reflect** on the results and the process
      logseq.order-list-type:: number
      - Questions to ask:
        - Have we interacted with all important customers in
          our target market?
        - Can we see the latent needs of customers beyond
          our current product range?
        - Can we further involve any of the customers in our
          product development?
        - Did we involve the right people in our organisation?
        - Can we improve our process?
