- ### Deadlines and schedules for next week
  - query-table:: false
    #+BEGIN_QUERY
    {:title "next week deadline or schedule"
    :query [:find (pull ?block [*])
    :in $ ?start ?next
    :where
    (or
    [?block :block/scheduled ?d]
    [?block :block/deadline ?d])
    [(> ?d ?start)]
    [(< ?d ?next)]]
    :inputs [:today :7d-after]
    :collapsed? false}
    #+END_QUERY
- ### Now / later
  - {{query (and [[LATER]] (not [[excluded_in_query]] )) }}
    query-table:: false
    query-sort-by:: clock-time
    query-sort-desc:: false
  - {{query #NOW }}
    query-table:: false
    query-sort-by:: block
    query-sort-desc:: true
    collapsed:: true
- ### Todo / doing
  - ### Doing
    {{query #DOING }}
  - ### Todo
    collapsed:: true
    {{query #TODO }}
    - ### Done
      {{query #DONE }}
- ### Done
  {{query #DONE }}
